/*  Copyright (C) 2008--2009 Joshua Judson Rosen <rozzin@geekspace.com>.

    This program is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 3 as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, see
    <http://www.gnu.org/licenses/> or write to:

        The Free Software Foundation, inc.
        51 Franklin Street, Fifth Floor
        Boston, MA 02110-1301
        USA
*/

#ifndef VISUALID_FIGURE_H
#define VISUALID_FIGURE_H

struct figure_generator {
  VisualID_Glyph base;

  VisualID_Glyph *head;
  double head_scale;

  VisualID_Glyph *leg;
  double leg_scale;

  VisualID_Glyph *tail;
  double tail_scale;
};

VisualID_Glyph *gen_figure (VisualID_Glyph *parent, const char *attachment);

#define VISUALID_TYPE_FIGURE            (visualid_figure_get_type ())
#define VISUALID_FIGURE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), VISUALID_TYPE_FIGURE, VisualID_Figure))
#define VISUALID_IS_FIGURE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VISUALID_TYPE_FIGURE))
#define VISUALID_FIGURE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), VISUALID_TYPE_FIGURE, VisualID_FigureClass))
#define VISUALID_IS_FIGURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VISUALID_TYPE_FIGURE))
#define VISUALID_FIGURE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), VISUALID_TYPE_FIGURE, VisualID_FigureClass))

typedef struct figure_generator VisualID_Figure;
typedef struct _VisualID_FigureClass VisualID_FigureClass;

GType visualid_figure_get_type (void);

#endif
