/*  Copyright (C) 2008--2009 Joshua Judson Rosen <rozzin@geekspace.com>.

    This program is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 3 as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, see
    <http://www.gnu.org/licenses/> or write to:

        The Free Software Foundation, inc.
        51 Franklin Street, Fifth Floor
        Boston, MA 02110-1301
        USA
*/

#ifndef VISUALID_SHAPE_H
#define VISUALID_SHAPE_H

#define VISUALID_TYPE_SHAPE            (visualid_shape_get_type ())
#define VISUALID_SHAPE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), VISUALID_TYPE_SHAPE, VisualID_Shape))
#define VISUALID_IS_SHAPE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VISUALID_TYPE_SHAPE))
#define VISUALID_SHAPE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), VISUALID_TYPE_SHAPE, VisualID_Shape))
#define VISUALID_IS_SHAPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VISUALID_TYPE_SHAPE))
#define VISUALID_SHAPE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), VISUALID_TYPE_SHAPE, VisualID_Shape))

typedef struct shape_generator VisualID_Shape;
typedef struct _VisualID_ShapeClass VisualID_ShapeClass;

GType visualid_shape_get_type (void);

VisualID_Glyph *gen_shape (VisualID_Glyph *parent, const char *attachment);

#endif
